<?php
/*
Plugin Name: Willcode FB Pixel integration
Plugin URI: http://yourls.org/
Description: Integrate with Facebook Meta pixel
Version: 0.1
Author: William Gustavo Marquetti
Author URI: willcode.tech
*/

// No direct call
if( !defined( 'YOURLS_ABSPATH' ) ) die();

/* Example of an action
 *
 * We're going to add an entry to the menu.
 *
 * The menu is drawn by function yourls_html_menu() in file includes/functions-html.php.
 * Right before the function outputs the closing </ul>, notice the following function call:
 * yourls_do_action( 'admin_menu' );
 * This function says: "hey, for your information, I've just done something called 'admin menu', thought I'd let you know..."
 *
 * We're going to hook into this action and add our menu entry
 */
yourls_add_action( 'pre_redirect', 'send_fb_pixel' );

function send_fb_pixel( $args ){

  try {
    $url = $args[0];
    $api_key = "EAAKerVh0Q6oBAP1zEREkMdaryitrPRllzb9abMZBJuT7CZAYwjdouJTv2yYB1nYYVlbPfilA9oJwYmpa8gL19D3DjfCtHx3ZCWOiMXkxtjX5yUOhi5UX25o2IpLOiMbf6FJJokAEC4cvOFY151tEonMZAWoSyvFN544W5NoiNaI6vHWGZBUZBvw7eAKnXijwMZD";
  
    /*  */
  
    $url_components = parse_url($args[0]);
    if ( $url_components ){
  
      // Use parse_str() function to parse the
      // string passed via URL
      parse_str($url_components['query'], $parameters);
      $pixel_id = "";
      $event = "PageView";
      $event_list = [ "PageView" ];
      if ( $parameters['wcode_fb_pixel_id'] ){
        $pixel_id = $parameters['wcode_fb_pixel_id'];
     
        if ( isset($parameters['wcode_fb_pixel_event']) ){
          if ( in_array($parameters['wcode_fb_pixel_event'], $event_list) ){
            $event = $parameters['wcode_fb_pixel_event'];
          }
        }
        $api_url = "https://graph.facebook.com/v11.0/{$pixel_id}/events";
      
        $data = [ // main object
                  
          "data" => [ // data array
              
            [
              "event_name" => $event, //"PageView",
              "event_time" => time(),
                "user_data" => [
                "client_ip_address" => '',
                "client_user_agent" => '',
                "em" => hash('sha256', ''),
                "ph" => '',
                "fbc" =>'',
                "fbp" =>''
              ],
              "action_source" => "website",
              "event_source_url"  => $url,
            ],
          ],
          "access_token" => $api_key,
        ];
          
        /*  */
        $dataString = json_encode($data);                                                                                                              
        $ch = curl_init($api_url);                                                                      
          curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");                                                                     
          curl_setopt($ch, CURLOPT_POSTFIELDS, $dataString);                                                                  
          curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);                                                                      
          curl_setopt($ch, CURLOPT_HTTPHEADER, [                                                                          
            'Content-Type: application/json',                                                                                
            'Content-Length: ' . strlen($dataString)
          ]                                                                    
        );                                                                                                                                                                       
        $response = curl_exec($ch);
      
        /*
        echo "<pre>";
        var_dump($response);
  
        die();
        */
      }
     
    }

  }catch ( Exception $error ){
    
  }

}
